% % Add user-defined preamble here.
% % Example: listing style or acronyms

%\lstdefinestyle{numbers}{
%	numbers=right,
%	stepnumber=1,
%	numberstyle=\tiny\color{magenta},
%	numbersep=-7pt
%}

\begin{acronym}
	\acro{abac}[ABAC]{Attribute Based Access Control}
	\acro{alfa}[ALFA]{Abbreviated Language For Authorisation}
	\acro{am}[AM]{Attribute Manager}
	\acro{ar}[AR]{Attribute Retriever}
	\acro{at}[AT]{Attribute Table}
	\acro{can}[CAN]{Controller Area Network}
	\acro{ch}[CH]{Context Handler}
	\acro{dac}[DAC]{Discretionary Access Control}
	\acro{drm}[DRM]{Digital Rights Management}
	\acro{ecu}[ECU]{Electronic Control Unit}
	\acro{ifttt}[IFTTT]{IF This Then That}
	\acro{iam}[IAM]{Identity and Access Management}
	\acro{idp}[IdP]{Identity Provider}
	\acro{ioe}[IoE]{Internet of Everything}
	\acro{iot}[IoT]{Internet of Things}
	\acro{iov}[IoV]{Internet of Vehicles}
	\acro{ipr}[IPR]{Intellectual Property Rights}
	\acro{json}[JSON]{JavaScript Object Notation}
	\acro{jws}[JWS]{JSON Web Signatures}
	\acro{jwt}[JWT]{JSON Web Token}
	\acro{lbac}[LBAC]{Lattice Based Access Control}
	\acro{mac}[MAC]{Mandatory Access Control}
	\acro{obd2}[OBD-II]{On-Board Diagnostics-II}
	\acro{oem}[OEM]{Original Equipment Manufacturer}
	\acro{om}[OM]{Obligation Manager}
	\acro{pap}[PAP]{Policy Administration Point}
	\acro{pdp}[PDP]{Policy Decision Point}
	\acro{pep}[PEP]{Policy Enforcement Point}
	\acro{pip}[PIP]{Policy Information Point}
	\acro{polp}[PoLP]{Principle of Least Privilege}
	\acro{pubsub}[Pub/Sub]{Publish/Subscribe}
	\acro{rbac}[RBAC]{Role Based Access Control}
	\acro{rebac}[ReBAC]{Relationship Based Access Control}
	\acro{siuv}[SIUV]{Smart-car Identity management and Usage control system based on Verifiable credentials}
	\acro{sm}[SM]{Session Manager}
	\acro{soa}[SOA]{Service-Oriented Architecture}
	\acro{sts}[STS]{Security Token Service}
	\acro{tm}[TM]{Trust Management}
	\acro{ucon}[UCON]{Usage Control}
	\acro{ucs}[UCS]{Usage Control System}
	\acro{ucsp}[UCS+]{Usage Control System Plus}
	\acrodefplural{ucsp}[UCS+ instances]{Usage Control System Plus instances}
	\acro{vc}[VC]{Verifiable Credential}
	\acro{vdr}[VDR]{Verifiable Data Registry}
	\acro{wfms}[WfMS]{Workflow Management System}
	\acro{xacml}[XACML]{eXtensible Access Control Markup Language}
	\acro{zta}[ZTA]{Zero-Trust Architecture}
	\acro{ztn}[ZTN]{Zero-Trust Networks}
\end{acronym}

\pgfplotsset{compat=1.14}

\pagestyle{plain}
\renewcommand\UrlFont{\color{blue}\rmfamily}

\definecolor{light-gray}{gray}{0.95}
\definecolor{darkgreen}{rgb}{0.0, 0.2, 0.13}

\newcommand\tab[1][1cm]{\hspace*{#1}}

\lstdefinestyle{numbers}{
	numbers=right,
	stepnumber=1,
	numberstyle=\tiny\color{magenta},
	numbersep=-7pt
}

\lstdefinestyle{MyFrame}{
	basicstyle={\scriptsize},
	backgroundcolor=\color{gray!10},
	xleftmargin=0.5em,
	xrightmargin=0.5em,
	framexrightmargin=0.5em,
	frame=shadowbox,
	frame=single,
	breaklines=true,
	linewidth=\linewidth,
	postbreak=\raisebox{0ex}[0ex][0ex]{\ensuremath{\color{blue}\hookrightarrow\space}},
	columns=fullflexible,
	captionpos=t,
	tabsize=4,
	showstringspaces=false,
	breakatwhitespace=false,
}

\lstset{
	style=numbers,
	style=MyFrame,
	escapechar={|},
	stringstyle=\color{gray},
	identifierstyle=\color{black},
	keywordstyle=\color{blue},
	upquote=true,
	morekeywords={policy, target, clause, rule, condition, on, permit, obligation, Attributes, in, @context, credentialSubject, id, issuanceDate, issuer, type, apply},
}

\colorlet{punct}{red!60!black}
\definecolor{background}{HTML}{EEEEEE}
\definecolor{delim}{RGB}{20,105,176}
\colorlet{numb}{magenta!60!black}

\lstdefinelanguage{json}{
	numbers=right,
	stepnumber=1,
	numbersep=0pt,
	showstringspaces=false,
	breaklines=true,
	frame=single,
	framexrightmargin=0.5em,
	upquote=true,
	keywordstyle=\color{blue},
	morekeywords={@context, credentialSubject, id, issuanceDate, issuer, type},
	literate=
	{:}{{{\color{punct}{:}}}}{1}
	{,}{{{\color{punct}{,}}}}{1}
	{\{}{{{\color{delim}{\{}}}}{1}
	{\}}{{{\color{delim}{\}}}}}{1}
	{[}{{{\color{delim}{[}}}}{1}
	{]}{{{\color{delim}{]}}}}{1},
}


\begin{filecontents}{eval_perf.dat}
	X attr eval	
	1 1	 9
	2 3	 11
	3 5	 18
	4 10 27
	5 20 29
\end{filecontents}

\begin{filecontents}{vc_perf.dat}
	X claims issuance verification	
	1 1	 86	 115
	2 3	 97	 119
	3 5	 105 125
	4 10 136 142
	5 20 196 172
\end{filecontents}

\begin{filecontents}{polp_perf.dat}
	X privileges polp	
	1 1	 300
	2 3	 952
	3 5	 1554
	4 10 3136
\end{filecontents}